<template>
  <div class="container h-100 d-flex justify-content-center align-items-center">
    <div class="col-lg-8">
      <h1 class="text-center mb-4">Groups</h1>
      <div v-if="serverMessage" class="alert" :class="serverMessage.type">
    {{ serverMessage.text }}
  </div>
       <!-- Button trigger modal -->
      <button type="button" class="btn btn-primary mb-3" @click="showModals = true">
        Create Group
      </button>

     <!-- Modal -->
      <div class="modal" :class="{ 'd-block': showModals, 'show': showModals }" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">New Group</h5>
              <button type="button" class="close" @click="showModals = false">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <!-- Add your form for creating an expense here -->
              <form  @submit.prevent="createGroup">
                <div style="margin-bottom: 1cm;" class="form-group">
                  <label for="title">Name</label>
                  <input v-model="newGroup.name" type="text" class="form-control" id="title" placeholder="Enter Name">
                </div>
                <div class="form-group">
            <label for="members">Members</label>
            <select v-model="newGroup.members" id="members" class="form-control" multiple>
              <option v-for="user in users" :value="user.id">{{ user.username }}</option>
            </select>
          </div> 
                <button type="submit" class="btn btn-primary">Save changes</button>
              </form>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-secondary" @click="showModals = false">Close</button>
              
            </div>
          </div>
        </div>
      </div>

      <table class="table table-striped">
        <thead>
          <tr>
            <th scope="col">#</th>
            <th scope="col">Group Name</th>
            <th scope="col">Actions</th>
          </tr>
        </thead>
        <tbody>
          <!-- <tr v-for="(group, index) in groups" :key="group.id"> -->
            <tr v-for="(group, index) in groups.filter(group => group)" :key="group.id">
            <th scope="row">{{ index + 1 }}</th>
            <td>{{ group.name }}</td>
            <td>
              <!-- <button class="btn btn-primary" @click="selectedGroup = group; showModal = true">Add Members</button> &nbsp; &nbsp; -->
              <button class="btn btn-success" @click="fetchGroupMembers(group)">Show Members</button>
            </td>
          </tr>
        </tbody>
      </table>

      <div class="card" v-if="groupMembers.length">
    <div class="card-header">
      Members of {{ selectedGroup.name }}
    </div>
    <ul class="list-group list-group-flush">
      <li class="list-group-item" v-for="member in groupMembers" :key="member.id">{{ member.username }}</li>
    </ul>
  </div>

    <div class="modal" v-if="selectedGroup" :class="{ 'd-block': showModal, 'show': showModal }" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">Add Members to {{ selectedGroup.name }}</h5>
              <button type="button" class="close" @click="showModal = false">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <select class="form-control" v-model="selectedUserId" id="users" multiple>
                <option v-for="user in users" :value="user.id">{{ user.username }}</option>
              </select>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-secondary" @click="showModal = false">Close</button>
              <button type="button" class="btn btn-primary" @click="addMemberToGroup">Add Members</button>
            </div>
          </div>
        </div>
      </div>


    </div>
  </div>
</template>

<script>
import { POST_GROUP, GET_USER_GROUPS, GET_USERS, ADD_MEMBER_TO_GROUP, GET_GROUP_MEMBERS, GET_GROUP_KEYS, POST_GROUP_KEYS } from "../api/api.js";
import JSEncrypt from 'jsencrypt';
import CryptoJS from 'crypto-js';
export default {
  name: 'GroupView',
  data() {
    return {
      groups: [],
      newGroup: {
        name: "",
        members: []
      },
      currentUser: JSON.parse(sessionStorage.getItem('token')),
      users: [],
      groupMembers: [],
      showModal: false,
      showModals: false,
      selectedGroup: null, // You should fetch the groups from your API and assign them to this array
      selectedUserId: null
    }
  },
  methods:{
    createGroup() {
      // Sanitize inputs
    const sanitizedGroupName = this.sanitizeInput(this.newGroup.name);
       // Generate a group key
       const groupKey = CryptoJS.lib.WordArray.random(64/8).toString();
       console.log('Generated groupKey:', groupKey);

       // Encrypt the group name with the group key
      const encryptedGroupName = CryptoJS.AES.encrypt(sanitizedGroupName, groupKey).toString();

       // Create the group
       POST_GROUP({ name: encryptedGroupName, members: this.newGroup.members })
        .then((data) => {
          // Encrypt the group key with the public key of each member
         const encryptedGroupKeys = this.newGroup.members.map(memberId => {
          const member = this.users.find(user => user.id === memberId);
          const crypt = new JSEncrypt();
          crypt.setPublicKey(member.publicKey);
          const encryptedGroupKey = crypt.encrypt(groupKey);
          if (encryptedGroupKey === false) {
    console.error('Encryption failed for user', member.id);
    console.error('Public key:', member.publicKey);
    console.error('Group key:', groupKey);
  }
          return {
            userId: member.id,
            encryptedGroupKey: encryptedGroupKey
          };
        });
          // Save the encrypted group keys
          POST_GROUP_KEYS({ groupId: data.id, keys: encryptedGroupKeys })
            .then(() => {
              this.showModal = false;
              this.fetchGroups(this.currentUser.id);
              // this.groups.push(data);
              this.newGroup.name = "";
              this.newGroup.members = [];
              this.serverMessage = { type: 'alert-success', text: 'Group created successfully!' };
            })
            .catch((e) => {
              console.log(e);
              this.serverMessage = { type: 'alert-danger', text: e.message || 'An error occurred.' };
            });
        })
        .catch((e) => {
          console.log(e);
          this.serverMessage = { type: 'alert-danger', text: e.message || 'An error occurred.' };
        });

    },
    fetchGroups() {
      console.log(this.currentUser);
    GET_USER_GROUPS(this.currentUser.id)
      .then((data) => {
        const crypt = new JSEncrypt();
        const privateKey = localStorage.getItem('privateKey');
        console.log(privateKey); // Replace 'privateKey' with the actual key you used to store the private key
        crypt.setPrivateKey(privateKey);
        console.log(data);
        const decryptedGroups = data.map(group => {
          console.log("hello");
          console.log("group",group.id);
          // Fetch the group keys for this group
          return GET_GROUP_KEYS(group.id)
            .then((response) => {
              const groupKeys = response.groupKeys;
              console.log(groupKeys);  
              // Find the group key for the current user
              //const userGroupKey = groupKeys.find(key => key.userId === this.currentUser.id);
              const userGroupKey = groupKeys.find(key => key.userId === this.currentUser.id);
              
              console.log("logging");
              console.log(groupKeys);// Replace 'this.currentUser.id' with the actual current user's ID
              console.log('userGroupKey:', userGroupKey);
          
              if (!userGroupKey) {
                console.error('No group key found for user', this.currentUser.id);
                return null;
              }

              // Decrypt the group key with the user's private key
              const decryptedGroupKey = crypt.decrypt(userGroupKey.encryptedKey);
              console.log('localStorage:', privateKey);
              console.log('decryptedGroupKey:', decryptedGroupKey);

              if (!decryptedGroupKey) {
                console.error('Failed to decrypt group key for user', this.currentUser.id);
                return null;
              }

              // Decrypt the group name with the decrypted group key
              const decryptedGroupName = CryptoJS.AES.decrypt(group.name, decryptedGroupKey).toString(CryptoJS.enc.Utf8);

              return {
                ...group,
                name: decryptedGroupName
              };
            });
        });

        // Wait for all group keys to be fetched and decrypted
        Promise.all(decryptedGroups)
          .then((groups) => {
            
            this.groups = groups;
            console.log(this.groups);
          });
      })
      .catch((e) => {
        // console.log("errors")
        console.log(e);
      });
  },


    fetchUsers() {
      GET_USERS()
        .then((data) => {
          this.users = data;
          console.log(data);
        })
        .catch((e) => {
          console.log(e);
        });
    },
    addMemberToGroup() {
      ADD_MEMBER_TO_GROUP(this.selectedGroup.id, this.selectedUserId)
        .then((data) => {
          this.showModal = false;
          this.serverMessage = { type: 'alert-success', text: 'Member added successfully!' };
        })
        .catch((e) => {
          console.log(e);
          this.serverMessage = { type: 'alert-danger', text: e.message || 'An error occurred.' };
        });
    },
    fetchGroupMembers(group) {
      if (!group) {
        console.error('No group provided');
       return;
        }
      this.selectedGroup = group;
      GET_GROUP_MEMBERS(group.id)
        .then((data) => {
          this.groupMembers = data;
          this.fetchGroupKeys(group.id);
        })
        .catch((e) => {
          console.log(e);
        });
    },
    sanitizeInput(input) {
    // Remove script tags, encode special characters, or use a library like DOMPurify
    return input.replace(/<script.*?>.*?<\/script>/gi, '').trim();
  },
    fetchGroupKeys(groupId) {
    GET_GROUP_KEYS(groupId)
      .then((data) => {
        console.log('Group keys for group', groupId, ':', data);
        // Do something with the group keys...
      })
      .catch((e) => {
        console.error('Failed to fetch group keys for group', groupId, ':', e);
      });
  }
  },
  mounted(){
    this.fetchGroups(),
    this.fetchUsers(),
    // this.fetchGroupMembers(),
    this.fetchGroupKeys()
  }
}
</script>

<style scoped>
.container {
  height: 100vh; /* Full height of the viewport */
}
</style>